window.Gleam.initSearch([{"doc":"scrapbook","title":"scrapbook","content":"# scrapbook\n\nGleam package for the Erlang target that can scrape parts of Facebook.\n\n**Currently this package only supports scraping events!**\n\n[![Package Version](https://img.shields.io/hexpm/v/scrapbook)](https://hex.pm/packages/scrapbook)\n[![Package License](https://img.shields.io/hexpm/l/scrapbook)](https://hex.pm/packages/scrapbook)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/scrapbook/)\n![Target: Erlang](https://img.shields.io/badge/target-erlang-a90432)\n\n```sh\ngleam add scrapbook\n```\n\n```gleam\nimport gleam/io\nimport scrapbook/event\n\npub fn main() {\n  let event =\n    event.scrape_from_url(\n      &quot;https://www.facebook.com/events/1137956700212933/1137956706879599/&quot;,\n    )\n  io.debug(event)\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/scrapbook&gt;.\n\nAll contributions are welcome. If you have any questions, please create an issue in the repository.\n\n## Other information\n\nFacebook&#39;s terms of service prohibit automated scraping of their site. Use this package at your own risk.\n\nRead more: [Automated Data Collection Terms](https://www.facebook.com/legal/automated_data_collection_terms)\n\n## Acknowledgements\n\n- [@francescov1](https://github.com/francescov1) for the [facebook-event-scraper](https://github.com/francescov1/facebook-event-scraper) (MIT) TypeScript library, which was an inspiration and the basis for the event scraping logic.\n","url":"index.html"},{"doc":"scrapbook/event","title":"EventBasicData","content":"pub opaque type EventBasicData\n\n\nSynonyms:\nscrapbook/event.EventBasicData\nscrapbook/event EventBasicData","url":"scrapbook/event.html#EventBasicData"},{"doc":"scrapbook/event","title":"EventData","content":"pub opaque type EventData\n\n\nSynonyms:\nscrapbook/event.EventData\nscrapbook/event EventData","url":"scrapbook/event.html#EventData"},{"doc":"scrapbook/event","title":"EventDataError","content":"pub type EventDataError {\n  FindKeyValueError(error: html.FindKeyValueError)\n  DataFormatErrors(errors: List(EventDataFormatError))\n}\n This type represents the reasons why reading the desired key value failed.\nFindKeyValueError(error: html.FindKeyValueError)\n Error in finding the desired key or its value.\n\nDataFormatErrors(errors: List(EventDataFormatError))\n Error decoding the JSON.\n\nSynonyms:\nscrapbook/event.EventDataError\nscrapbook/event EventDataError","url":"scrapbook/event.html#EventDataError"},{"doc":"scrapbook/event","title":"EventDataFormatError","content":"pub type EventDataFormatError {\n  DecodeError(error: json.DecodeError)\n  ValidateError\n}\n This type represents the reasons why decoding of the JSON failed.\nDecodeError(error: json.DecodeError)\n Error decoding JSON structure.\n\nValidateError\n Error validating decoded data with the passed validator.\n\nSynonyms:\nscrapbook/event.EventDataFormatError\nscrapbook/event EventDataFormatError","url":"scrapbook/event.html#EventDataFormatError"},{"doc":"scrapbook/event","title":"EventHost","content":"pub opaque type EventHost\n\n\nSynonyms:\nscrapbook/event.EventHost\nscrapbook/event EventHost","url":"scrapbook/event.html#EventHost"},{"doc":"scrapbook/event","title":"EventParent","content":"pub opaque type EventParent\n\n\nSynonyms:\nscrapbook/event.EventParent\nscrapbook/event EventParent","url":"scrapbook/event.html#EventParent"},{"doc":"scrapbook/event","title":"EventPhoto","content":"pub opaque type EventPhoto\n\n\nSynonyms:\nscrapbook/event.EventPhoto\nscrapbook/event EventPhoto","url":"scrapbook/event.html#EventPhoto"},{"doc":"scrapbook/event","title":"EventPlace","content":"pub opaque type EventPlace\n\n\nSynonyms:\nscrapbook/event.EventPlace\nscrapbook/event EventPlace","url":"scrapbook/event.html#EventPlace"},{"doc":"scrapbook/event","title":"EventSibling","content":"pub opaque type EventSibling\n\n\nSynonyms:\nscrapbook/event.EventSibling\nscrapbook/event EventSibling","url":"scrapbook/event.html#EventSibling"},{"doc":"scrapbook/event","title":"EventTimeDetails","content":"pub opaque type EventTimeDetails\n\n\nSynonyms:\nscrapbook/event.EventTimeDetails\nscrapbook/event EventTimeDetails","url":"scrapbook/event.html#EventTimeDetails"},{"doc":"scrapbook/event","title":"EventVideo","content":"pub opaque type EventVideo\n\n\nSynonyms:\nscrapbook/event.EventVideo\nscrapbook/event EventVideo","url":"scrapbook/event.html#EventVideo"},{"doc":"scrapbook/event","title":"FetchError","content":"pub type FetchError {\n  RequestConstructionError(url: String)\n  RequestSendError(error: Dynamic)\n  FollowRedirectionError\n}\n This type represents the reasons why fetching the HTTP data might fail.\nRequestConstructionError(url: String)\n Error constructing request from URL.\n\nRequestSendError(error: Dynamic)\n Error sending the request coming from a client.\n\nFollowRedirectionError\n Error following the redirection - no target URL found.\n\nSynonyms:\nscrapbook/event.FetchError\nscrapbook/event FetchError","url":"scrapbook/event.html#FetchError"},{"doc":"scrapbook/event","title":"HostType","content":"pub type HostType {\n  User\n  Page\n}\n\nUser\n\n\nPage\n\n\nSynonyms:\nscrapbook/event.HostType\nscrapbook/event HostType","url":"scrapbook/event.html#HostType"},{"doc":"scrapbook/event","title":"OfflineCity","content":"pub opaque type OfflineCity\n\n\nSynonyms:\nscrapbook/event.OfflineCity\nscrapbook/event OfflineCity","url":"scrapbook/event.html#OfflineCity"},{"doc":"scrapbook/event","title":"OfflineLocation","content":"pub opaque type OfflineLocation\n\n\nSynonyms:\nscrapbook/event.OfflineLocation\nscrapbook/event OfflineLocation","url":"scrapbook/event.html#OfflineLocation"},{"doc":"scrapbook/event","title":"OfflineType","content":"pub type OfflineType {\n  Text\n  Place\n  City\n}\n\nText\n\n\nPlace\n\n\nCity\n\n\nSynonyms:\nscrapbook/event.OfflineType\nscrapbook/event OfflineType","url":"scrapbook/event.html#OfflineType"},{"doc":"scrapbook/event","title":"OnlineType","content":"pub type OnlineType {\n  MessengerRoom\n  ThirdParty\n  FacebookLive\n  Other\n}\n\nMessengerRoom\n\n\nThirdParty\n\n\nFacebookLive\n\n\nOther\n\n\nSynonyms:\nscrapbook/event.OnlineType\nscrapbook/event OnlineType","url":"scrapbook/event.html#OnlineType"},{"doc":"scrapbook/event","title":"ScrapeError","content":"pub type ScrapeError {\n  UrlError\n  FetchError(error: FetchError)\n  EventDataError(error: EventDataError)\n}\n This type represents the reasons why scraping the event might fail.\nUrlError\n Error creating the target URL from the input.\n\nFetchError(error: FetchError)\n Error retrieving event data.\n\nEventDataError(error: EventDataError)\n Error caused by retrieved data that could not be parsed properly.\n\nSynonyms:\nscrapbook/event.ScrapeError\nscrapbook/event ScrapeError","url":"scrapbook/event.html#ScrapeError"},{"doc":"scrapbook/event","title":"get_event","content":"pub fn get_event(\n  html: String,\n) -&gt; Result(EventData, EventDataError)\n Get all possible event data from the given HTML string.\nSynonyms:\nscrapbook/event.get_event\nscrapbook/event get_event","url":"scrapbook/event.html#get_event"},{"doc":"scrapbook/event","title":"scrape_from_fbid","content":"pub fn scrape_from_fbid(\n  fbid: String,\n) -&gt; Result(EventData, ScrapeError)\n Scrape an event from the specified event fbid.\nSynonyms:\nscrapbook/event.scrape_from_fbid\nscrapbook/event scrape_from_fbid","url":"scrapbook/event.html#scrape_from_fbid"},{"doc":"scrapbook/event","title":"scrape_from_url","content":"pub fn scrape_from_url(\n  url: String,\n) -&gt; Result(EventData, ScrapeError)\n Scrape an event from the specified event URL.\nSynonyms:\nscrapbook/event.scrape_from_url\nscrapbook/event scrape_from_url","url":"scrapbook/event.html#scrape_from_url"},{"doc":"scrapbook/event","title":"scrapbook/event","content":"","url":"scrapbook/event.html"}]);